com.saxonica.validate

## Class FieldWatch

- java.lang.Object
- - com.saxonica.validate.AbstractWatch
  - - com.saxonica.validate.FieldWatch

- All Implemented Interfaces:
    Watch

      public class FieldWatch
      extends AbstractWatch

  A FieldWatch is a class that is looking for nodes that match a field selector within a uniqueness or key constraint.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `FieldWatch(SelectorWatch parentWatch, Pattern selection, AtomicSequence[] currentRow, int column)` Create a new FieldWatch

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `endSelectedParentNode(int locationId)` Signal that the endElement event has occurred for the element whose startElement event caused the Watch to be activated.
    `void` | `notifySelectedLeafNode(FleetingNode node, int locationId)` Signal that a node (other than an element) that matches the selection has been found.
    `Receiver` | `startSelectedParentNode(FleetingNode node, int locationId)` Signal that an element has been found that matches the selection that this Watch is looking for.

    - ### Methods inherited from class com.saxonica.validate.AbstractWatch

      `close, getAnchorNode, getNamespaceResolver, getPipelineConfiguration, getSelection, open, setAnchorNode, setNamespaceResolver, setPipelineConfiguration, setSelection`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### FieldWatch

          public FieldWatch(SelectorWatch parentWatch,
                    Pattern selection,
                    AtomicSequence[] currentRow,
                    int column)

      Create a new FieldWatch
      Parameters:
        `parentWatch` - The SelectorWatch to which field values should be notified
        `selection` - The selection (that is, the restricted XPath expression) used in this field of the constraint
        `currentRow` - represents the selected node whose fields are being evaluated
        `column` - sequence number for this field within the constraint being evaluated

  - ### Method Detail

    - #### startSelectedParentNode

          public Receiver startSelectedParentNode(FleetingNode node,
                                         int locationId)
                                           throws XPathException

      Signal that an element has been found that matches the selection that this Watch is looking for. This method is called by the ConstraintChecker while processing the startElement event that matches the selection. For this purpose, any attributes selected by the last step in the selection are ignored
      Parameters:
        `node` - the element or document node whose start event has been matched
        `locationId` - the location associated with the element or document node (may be the location of the instruction that created it)
      Returns:
        a Receiver to be notified of all events starting with the startElement/startDocument event for the matched element, and ending with the endElement event for that element; or null if this feature is not required.
      Throws:
        `ValidationException` - May be raised if the constraint implemented by this Watch is violated @param locationId
        `XPathException` - May be raised if a dynamic error occurs

    - #### endSelectedParentNode

          public void endSelectedParentNode(int locationId)
                                     throws ValidationException

      Signal that the endElement event has occurred for the element whose startElement event caused the Watch to be activated.
      Parameters:
        `locationId` - the location of the element
      Throws:
        `ValidationException` - May be raised if the constraint implemented by this Watch is violated @param locationId

    - #### notifySelectedLeafNode

          public void notifySelectedLeafNode(FleetingNode node,
                                    int locationId)
                                      throws XPathException

      Signal that a node (other than an element) that matches the selection has been found.
      Specified by:
        `notifySelectedLeafNode` in interface `Watch`
      Overrides:
        `notifySelectedLeafNode` in class `AbstractWatch`
      Parameters:
        `node` - the node that was matched.
        `locationId` - location for error reporting purposes
      Throws:
        `XPathException`

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.